"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InlineLoading = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const classNames_1 = require("../../utils/classNames");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const pro_solid_svg_icons_1 = require("@fortawesome/pro-solid-svg-icons");
const getStateIcon = (state) => {
    switch (state) {
        case 'loading':
            return pro_solid_svg_icons_1.faSpinnerThird;
        case 'success':
            return pro_solid_svg_icons_1.faCircleCheck;
        case 'error':
            return pro_solid_svg_icons_1.faCircleXmark;
    }
};
const InlineLoading = ({ state = 'loading', message = 'Loading...', className, ...props }) => {
    const classes = (0, classNames_1.classNames)('bas inline-loading', state, className);
    return ((0, jsx_runtime_1.jsxs)("span", { ...props, className: classes, children: [(0, jsx_runtime_1.jsx)("div", { className: "icon-wrapper", children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: getStateIcon(state), className: state === 'loading' ? 'fa-spin' : '' }) }), (0, jsx_runtime_1.jsx)("span", { className: "message", children: message })] }));
};
exports.InlineLoading = InlineLoading;
//# sourceMappingURL=InlineLoading.js.map