"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Input = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const classNames_1 = require("../../utils/classNames");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const pro_solid_svg_icons_1 = require("@fortawesome/pro-solid-svg-icons");
const Input = ({ className, icon: baseIcon, onClickIcon: baseOnClickIcon, groupIcon, state, error, onChange, ...props }) => {
    const [revealPassword, setRevealPassword] = (0, react_1.useState)(false);
    const icon = props.type === 'password' ? ((0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: revealPassword ? pro_solid_svg_icons_1.faEyeSlash : pro_solid_svg_icons_1.faEye })) : (baseIcon);
    const onClickIcon = props.type === 'password'
        ? () => setRevealPassword((prevState) => !prevState)
        : baseOnClickIcon;
    const overrideType = props.type === 'password' && revealPassword && 'text';
    const classes = (0, classNames_1.classNames)('bas input', !!icon && 'icon-right', !!groupIcon && 'group-icon-left', state, props.disabled && 'disabled', className);
    return ((0, jsx_runtime_1.jsxs)("div", { className: classes, children: [groupIcon && (0, jsx_runtime_1.jsx)("span", { className: "group-icon", children: groupIcon }), (0, jsx_runtime_1.jsx)("input", { ...props, type: overrideType || props.type, onChange: (e) => onChange(e.currentTarget.value) }), (icon || state) && ((0, jsx_runtime_1.jsxs)("span", { className: (0, classNames_1.classNames)('icon', onClickIcon && 'clickable'), onClick: onClickIcon, children: [icon, state === 'error' && !icon && ((0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: pro_solid_svg_icons_1.faTriangleExclamation })), state === 'success' && !icon && (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: pro_solid_svg_icons_1.faCheck })] })), (0, jsx_runtime_1.jsx)("div", { className: "error-message", children: error })] }));
};
exports.Input = Input;
//# sourceMappingURL=Input.js.map