"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Modal = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const pro_regular_svg_icons_1 = require("@fortawesome/pro-regular-svg-icons");
const react_dom_1 = require("react-dom");
const Portal = ({ children }) => {
    const body = document.body;
    const element = (0, react_1.useMemo)(() => document.createElement('div'), []);
    element.className = 'bas modal';
    (0, react_1.useEffect)(() => {
        body.appendChild(element);
        return () => {
            body.removeChild(element);
        };
    }, [element, body]);
    return (0, react_dom_1.createPortal)(children, element);
};
const Modal = ({ children, headerComponent, footerComponent, show = false, onClose, size = 'small', maxHeight = 300, }) => {
    const modalRef = (0, react_1.useRef)(null);
    (0, react_1.useEffect)(() => {
        // close modal when user click on Esc
        const handleEsc = (e) => {
            if (e.key === 'Escape' && show) {
                onClose();
            }
        };
        window.addEventListener('keydown', (e) => handleEsc(e));
        return () => window.removeEventListener('keydown', (e) => handleEsc(e));
    }, [onClose, show]);
    const handleCloseModal = (e) => {
        var _a;
        const target = e.target;
        const { className } = target;
        // to handle out of modal click
        if (className !== 'modal' && !((_a = modalRef.current) === null || _a === void 0 ? void 0 : _a.contains(target))) {
            onClose();
        }
    };
    return ((0, jsx_runtime_1.jsx)(Portal, { children: (0, jsx_runtime_1.jsx)("div", { className: `${show ? 'show' : 'hide'}`, onClick: handleCloseModal, children: (0, jsx_runtime_1.jsx)("div", { className: "modal-container", children: (0, jsx_runtime_1.jsx)("div", { className: `modal-content ${size}`, children: (0, jsx_runtime_1.jsxs)("div", { ref: modalRef, className: "modal", children: [(0, jsx_runtime_1.jsxs)("div", { className: "modal-header", children: [(0, jsx_runtime_1.jsx)("div", { className: "modal-header-title", children: headerComponent }), (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: pro_regular_svg_icons_1.faXmark, onClick: onClose })] }), (0, jsx_runtime_1.jsx)("div", { className: "modal-body", style: { maxHeight: `${maxHeight}px` }, children: children }), (0, jsx_runtime_1.jsx)("div", { className: "modal-footer", children: footerComponent })] }) }) }) }) }));
};
exports.Modal = Modal;
//# sourceMappingURL=Modal.js.map